// Code generated by gocc; DO NOT EDIT.

package parser

import "miller/dsl"

type (
	//TODO: change type and variable names to be consistent with other tables
	ProdTab      [numProductions]ProdTabEntry
	ProdTabEntry struct {
		String     string
		Id         string
		NTType     int
		Index      int
		NumSymbols int
		ReduceFunc func([]Attrib) (Attrib, error)
	}
	Attrib interface {
	}
)

var productionsTable = ProdTab{
	ProdTabEntry{
		String: `S' : Root	<<  >>`,
		Id:         "S'",
		NTType:     0,
		Index:      0,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `Root : StatementBlock	<< dsl.NewAST(X[0]) >>`,
		Id:         "Root",
		NTType:     1,
		Index:      1,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewAST(X[0])
		},
	},
	ProdTabEntry{
		String: `StatementBlock : empty	<< dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock) >>`,
		Id:         "StatementBlock",
		NTType:     2,
		Index:      2,
		NumSymbols: 0,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `StatementBlock : NonEmptyStatementBlock	<< dsl.Wrap(X[0]) >>`,
		Id:         "StatementBlock",
		NTType:     2,
		Index:      3,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.Wrap(X[0])
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracelessStatement	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      4,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      5,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : ";" StatementBlock	<< dsl.Wrap(X[1]) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      6,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.Wrap(X[1])
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracelessStatement ";" StatementBlock	<< dsl.PrependChild(X[2], X[0]) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      7,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(X[2], X[0])
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement ";" StatementBlock	<< dsl.PrependChild(X[2], X[0]) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      8,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(X[2], X[0])
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement BracefulStatement StatementBlock	<< dsl.PrependTwoChildren(X[2], X[0], X[1]) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      9,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependTwoChildren(X[2], X[0], X[1])
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement BracelessStatement	<< dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeStatementBlock) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      10,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement BracelessStatement ";"	<< dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeStatementBlock) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      11,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `NonEmptyStatementBlock : BracefulStatement BracelessStatement ";" NonEmptyStatementBlock	<< dsl.PrependTwoChildren(X[3], X[0], X[1]) >>`,
		Id:         "NonEmptyStatementBlock",
		NTType:     3,
		Index:      12,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependTwoChildren(X[3], X[0], X[1])
		},
	},
	ProdTabEntry{
		String: `StatementBlockInBraces : "{" StatementBlock "}"	<< dsl.Wrap(X[1]) >>`,
		Id:         "StatementBlockInBraces",
		NTType:     4,
		Index:      13,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.Wrap(X[1])
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : Assignment	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      14,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : Unset	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      15,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : BareBoolean	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      16,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : FilterStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      17,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : EmitStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      18,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : DumpStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      19,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : EdumpStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      20,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : PrintStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      21,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : EprintStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      22,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : PrintnStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      23,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : EprintnStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      24,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : DoWhileLoop	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      25,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : BreakStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      26,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : ContinueStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      27,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : ReturnStatement	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      28,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracelessStatement : SubroutineCallsite	<<  >>`,
		Id:         "BracelessStatement",
		NTType:     5,
		Index:      29,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "=" Rvalue	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeAssignment) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      30,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeAssignment)
		},
	},
	ProdTabEntry{
		String: `Unset : unset Lvalue	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeUnset) >>`,
		Id:         "Unset",
		NTType:     7,
		Index:      31,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeUnset)
		},
	},
	ProdTabEntry{
		String: `Lvalue : Rvalue	<<  >>`,
		Id:         "Lvalue",
		NTType:     8,
		Index:      32,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `Lvalue : Typedecl LocalVariable	<< dsl.AppendChild(X[1], X[0]) >>`,
		Id:         "Lvalue",
		NTType:     8,
		Index:      33,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[1], X[0])
		},
	},
	ProdTabEntry{
		String: `BareBoolean : Rvalue	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeBareBoolean) >>`,
		Id:         "BareBoolean",
		NTType:     9,
		Index:      34,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeBareBoolean)
		},
	},
	ProdTabEntry{
		String: `FilterStatement : filter Rvalue	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeFilterStatement) >>`,
		Id:         "FilterStatement",
		NTType:     10,
		Index:      35,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeFilterStatement)
		},
	},
	ProdTabEntry{
		String: `EmitStatement : emit Rvalue	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeEmitStatement) >>`,
		Id:         "EmitStatement",
		NTType:     11,
		Index:      36,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeEmitStatement)
		},
	},
	ProdTabEntry{
		String: `DumpStatement : dump	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeDumpStatement) >>`,
		Id:         "DumpStatement",
		NTType:     12,
		Index:      37,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeDumpStatement)
		},
	},
	ProdTabEntry{
		String: `DumpStatement : dump FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypeDumpStatement,
      ),
      X[1],
    ) >>`,
		Id:         "DumpStatement",
		NTType:     12,
		Index:      38,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypeDumpStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `EdumpStatement : edump	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeEdumpStatement) >>`,
		Id:         "EdumpStatement",
		NTType:     13,
		Index:      39,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeEdumpStatement)
		},
	},
	ProdTabEntry{
		String: `EdumpStatement : edump FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypeEdumpStatement,
      ),
      X[1],
    ) >>`,
		Id:         "EdumpStatement",
		NTType:     13,
		Index:      40,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypeEdumpStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `PrintStatement : print	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypePrintStatement) >>`,
		Id:         "PrintStatement",
		NTType:     14,
		Index:      41,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypePrintStatement)
		},
	},
	ProdTabEntry{
		String: `PrintStatement : print FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypePrintStatement,
      ),
      X[1],
    ) >>`,
		Id:         "PrintStatement",
		NTType:     14,
		Index:      42,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypePrintStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `EprintStatement : eprint	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeEprintStatement) >>`,
		Id:         "EprintStatement",
		NTType:     15,
		Index:      43,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeEprintStatement)
		},
	},
	ProdTabEntry{
		String: `EprintStatement : eprint FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypeEprintStatement,
      ),
      X[1],
    ) >>`,
		Id:         "EprintStatement",
		NTType:     15,
		Index:      44,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypeEprintStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `PrintnStatement : printn	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypePrintnStatement) >>`,
		Id:         "PrintnStatement",
		NTType:     16,
		Index:      45,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypePrintnStatement)
		},
	},
	ProdTabEntry{
		String: `PrintnStatement : printn FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypePrintnStatement,
      ),
      X[1],
    ) >>`,
		Id:         "PrintnStatement",
		NTType:     16,
		Index:      46,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypePrintnStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `EprintnStatement : eprintn	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeEprintnStatement) >>`,
		Id:         "EprintnStatement",
		NTType:     17,
		Index:      47,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeEprintnStatement)
		},
	},
	ProdTabEntry{
		String: `EprintnStatement : eprintn FcnArgs	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypeEprintnStatement,
      ),
      X[1],
    ) >>`,
		Id:         "EprintnStatement",
		NTType:     17,
		Index:      48,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypeEprintnStatement,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `FieldValue : DirectFieldValue	<<  >>`,
		Id:         "FieldValue",
		NTType:     18,
		Index:      49,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FieldValue : IndirectFieldValue	<<  >>`,
		Id:         "FieldValue",
		NTType:     18,
		Index:      50,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FieldValue : BracedFieldValue	<<  >>`,
		Id:         "FieldValue",
		NTType:     18,
		Index:      51,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FieldValue : PositionalFieldName	<<  >>`,
		Id:         "FieldValue",
		NTType:     18,
		Index:      52,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FieldValue : PositionalFieldValue	<<  >>`,
		Id:         "FieldValue",
		NTType:     18,
		Index:      53,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `DirectFieldValue : field_name	<< dsl.NewASTNodeStripDollarOrAtSign(X[0], dsl.NodeTypeDirectFieldValue) >>`,
		Id:         "DirectFieldValue",
		NTType:     19,
		Index:      54,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeStripDollarOrAtSign(X[0], dsl.NodeTypeDirectFieldValue)
		},
	},
	ProdTabEntry{
		String: `IndirectFieldValue : "$[" Rvalue "]"	<< dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypeIndirectFieldValue) >>`,
		Id:         "IndirectFieldValue",
		NTType:     20,
		Index:      55,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypeIndirectFieldValue)
		},
	},
	ProdTabEntry{
		String: `BracedFieldValue : braced_field_name	<< dsl.NewASTNodeStripDollarOrAtSignAndCurlyBraces(X[0], dsl.NodeTypeDirectFieldValue) >>`,
		Id:         "BracedFieldValue",
		NTType:     21,
		Index:      56,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeStripDollarOrAtSignAndCurlyBraces(X[0], dsl.NodeTypeDirectFieldValue)
		},
	},
	ProdTabEntry{
		String: `PositionalFieldName : "$[[" Rvalue "]]"	<< dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypePositionalFieldName) >>`,
		Id:         "PositionalFieldName",
		NTType:     22,
		Index:      57,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypePositionalFieldName)
		},
	},
	ProdTabEntry{
		String: `PositionalFieldValue : "$[[[" Rvalue "]]]"	<< dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypePositionalFieldValue) >>`,
		Id:         "PositionalFieldValue",
		NTType:     23,
		Index:      58,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(dsl.NewASTToken("$[]", X[0]), X[1], dsl.NodeTypePositionalFieldValue)
		},
	},
	ProdTabEntry{
		String: `FullSrec : full_srec	<< dsl.NewASTNode(X[0], dsl.NodeTypeFullSrec) >>`,
		Id:         "FullSrec",
		NTType:     24,
		Index:      59,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeFullSrec)
		},
	},
	ProdTabEntry{
		String: `OosvarValue : DirectOosvarValue	<<  >>`,
		Id:         "OosvarValue",
		NTType:     25,
		Index:      60,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `OosvarValue : IndirectOosvarValue	<<  >>`,
		Id:         "OosvarValue",
		NTType:     25,
		Index:      61,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `OosvarValue : BracedOosvarValue	<<  >>`,
		Id:         "OosvarValue",
		NTType:     25,
		Index:      62,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `DirectOosvarValue : oosvar_name	<< dsl.NewASTNodeStripDollarOrAtSign(X[0], dsl.NodeTypeDirectOosvarValue) >>`,
		Id:         "DirectOosvarValue",
		NTType:     26,
		Index:      63,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeStripDollarOrAtSign(X[0], dsl.NodeTypeDirectOosvarValue)
		},
	},
	ProdTabEntry{
		String: `IndirectOosvarValue : "@[" Rvalue "]"	<< dsl.NewASTNodeUnary(dsl.NewASTToken("@[]", X[0]), X[1], dsl.NodeTypeIndirectOosvarValue) >>`,
		Id:         "IndirectOosvarValue",
		NTType:     27,
		Index:      64,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(dsl.NewASTToken("@[]", X[0]), X[1], dsl.NodeTypeIndirectOosvarValue)
		},
	},
	ProdTabEntry{
		String: `BracedOosvarValue : braced_oosvar_name	<< dsl.NewASTNodeStripDollarOrAtSignAndCurlyBraces(X[0], dsl.NodeTypeDirectOosvarValue) >>`,
		Id:         "BracedOosvarValue",
		NTType:     28,
		Index:      65,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeStripDollarOrAtSignAndCurlyBraces(X[0], dsl.NodeTypeDirectOosvarValue)
		},
	},
	ProdTabEntry{
		String: `FullOosvar : full_oosvar	<< dsl.NewASTNode(X[0], dsl.NodeTypeFullOosvar) >>`,
		Id:         "FullOosvar",
		NTType:     29,
		Index:      66,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeFullOosvar)
		},
	},
	ProdTabEntry{
		String: `LocalVariable : non_sigil_name	<< dsl.NewASTNode(X[0], dsl.NodeTypeLocalVariable) >>`,
		Id:         "LocalVariable",
		NTType:     30,
		Index:      67,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeLocalVariable)
		},
	},
	ProdTabEntry{
		String: `Typedecl : arr	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      68,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : bool	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      69,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : float	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      70,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : int	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      71,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : map	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      72,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : num	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      73,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : str	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      74,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Typedecl : var	<< dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl) >>`,
		Id:         "Typedecl",
		NTType:     31,
		Index:      75,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeTypedecl)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "||=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("||", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      76,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("||", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "^^=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      77,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "&&=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("&&", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      78,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("&&", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "??=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("??", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      79,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("??", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "???=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("???", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      80,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("???", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "|=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("|", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      81,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("|", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "&=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      82,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "^=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      83,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("^", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "<<=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("<<", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      84,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("<<", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue ">>=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(">"+">", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      85,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(">"+">", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue ">>>=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(">"+">"+">", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      86,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(">"+">"+">", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "+=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("+", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      87,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("+", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue ".=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(".", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      88,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken(".", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "-=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("-", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      89,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("-", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "*=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("*", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      90,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("*", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "/=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("/", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      91,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("/", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "//=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("//", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      92,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("//", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "%!=(MISSING)" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("%", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      93,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("%", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Assignment : Lvalue "**=" Rvalue	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("=", X[1]),
      X[0],
      dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("**", X[1]), X[0], X[2], dsl.NodeTypeOperator),
      dsl.NodeTypeAssignment,
    ) >>`,
		Id:         "Assignment",
		NTType:     6,
		Index:      94,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("=", X[1]),
				X[0],
				dsl.NewASTNodeBinaryNestable(dsl.NewASTToken("**", X[1]), X[0], X[2], dsl.NodeTypeOperator),
				dsl.NodeTypeAssignment,
			)
		},
	},
	ProdTabEntry{
		String: `Rvalue : PrecedenceChainStart	<<  >>`,
		Id:         "Rvalue",
		NTType:     32,
		Index:      95,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `PrecedenceChainStart : TernaryTerm	<<  >>`,
		Id:         "PrecedenceChainStart",
		NTType:     33,
		Index:      96,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `TernaryTerm : LogicalOrTerm "?" TernaryTerm ":" TernaryTerm	<< dsl.NewASTNodeTernary(dsl.NewASTToken("?:", X[1]), X[0], X[2], X[4], dsl.NodeTypeOperator) >>`,
		Id:         "TernaryTerm",
		NTType:     34,
		Index:      97,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(dsl.NewASTToken("?:", X[1]), X[0], X[2], X[4], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `TernaryTerm : LogicalOrTerm	<<  >>`,
		Id:         "TernaryTerm",
		NTType:     34,
		Index:      98,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `LogicalOrTerm : LogicalOrTerm "||" LogicalXORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "LogicalOrTerm",
		NTType:     35,
		Index:      99,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `LogicalOrTerm : LogicalXORTerm	<<  >>`,
		Id:         "LogicalOrTerm",
		NTType:     35,
		Index:      100,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `LogicalXORTerm : LogicalXORTerm "^^" LogicalAndTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "LogicalXORTerm",
		NTType:     36,
		Index:      101,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `LogicalXORTerm : LogicalAndTerm	<<  >>`,
		Id:         "LogicalXORTerm",
		NTType:     36,
		Index:      102,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `LogicalAndTerm : LogicalAndTerm "&&" AbsentCoalesceTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "LogicalAndTerm",
		NTType:     37,
		Index:      103,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `LogicalAndTerm : AbsentCoalesceTerm	<<  >>`,
		Id:         "LogicalAndTerm",
		NTType:     37,
		Index:      104,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `AbsentCoalesceTerm : AbsentCoalesceTerm "??" EmptyCoalesceTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AbsentCoalesceTerm",
		NTType:     38,
		Index:      105,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AbsentCoalesceTerm : EmptyCoalesceTerm	<<  >>`,
		Id:         "AbsentCoalesceTerm",
		NTType:     38,
		Index:      106,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `EmptyCoalesceTerm : EmptyCoalesceTerm "???" EqneTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "EmptyCoalesceTerm",
		NTType:     39,
		Index:      107,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `EmptyCoalesceTerm : EqneTerm	<<  >>`,
		Id:         "EmptyCoalesceTerm",
		NTType:     39,
		Index:      108,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `EqneTerm : EqneTerm "=~" CmpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "EqneTerm",
		NTType:     40,
		Index:      109,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `EqneTerm : EqneTerm "!=~" CmpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "EqneTerm",
		NTType:     40,
		Index:      110,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `EqneTerm : EqneTerm "==" CmpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "EqneTerm",
		NTType:     40,
		Index:      111,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `EqneTerm : EqneTerm "!=" CmpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "EqneTerm",
		NTType:     40,
		Index:      112,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `EqneTerm : CmpTerm	<<  >>`,
		Id:         "EqneTerm",
		NTType:     40,
		Index:      113,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `CmpTerm : CmpTerm ">" BitwiseORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "CmpTerm",
		NTType:     41,
		Index:      114,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `CmpTerm : CmpTerm ">=" BitwiseORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "CmpTerm",
		NTType:     41,
		Index:      115,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `CmpTerm : CmpTerm "<" BitwiseORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "CmpTerm",
		NTType:     41,
		Index:      116,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `CmpTerm : CmpTerm "<=" BitwiseORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "CmpTerm",
		NTType:     41,
		Index:      117,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `CmpTerm : BitwiseORTerm	<<  >>`,
		Id:         "CmpTerm",
		NTType:     41,
		Index:      118,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BitwiseORTerm : BitwiseORTerm "|" BitwiseXORTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseORTerm",
		NTType:     42,
		Index:      119,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseORTerm : BitwiseXORTerm	<<  >>`,
		Id:         "BitwiseORTerm",
		NTType:     42,
		Index:      120,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BitwiseXORTerm : BitwiseXORTerm "^" BitwiseANDTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseXORTerm",
		NTType:     43,
		Index:      121,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseXORTerm : BitwiseANDTerm	<<  >>`,
		Id:         "BitwiseXORTerm",
		NTType:     43,
		Index:      122,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BitwiseANDTerm : BitwiseANDTerm "&" BitwiseShiftTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseANDTerm",
		NTType:     44,
		Index:      123,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseANDTerm : BitwiseShiftTerm	<<  >>`,
		Id:         "BitwiseANDTerm",
		NTType:     44,
		Index:      124,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BitwiseShiftTerm : BitwiseShiftTerm "<<" AddsubdotTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseShiftTerm",
		NTType:     45,
		Index:      125,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseShiftTerm : BitwiseShiftTerm ">>" AddsubdotTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseShiftTerm",
		NTType:     45,
		Index:      126,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseShiftTerm : BitwiseShiftTerm ">>>" AddsubdotTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "BitwiseShiftTerm",
		NTType:     45,
		Index:      127,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `BitwiseShiftTerm : AddsubdotTerm	<<  >>`,
		Id:         "BitwiseShiftTerm",
		NTType:     45,
		Index:      128,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : AddsubdotTerm "+" MuldivTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      129,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : AddsubdotTerm "-" MuldivTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      130,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : AddsubdotTerm ".+" MuldivTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      131,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : AddsubdotTerm ".-" MuldivTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      132,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : AddsubdotTerm "." MuldivTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      133,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `AddsubdotTerm : MuldivTerm	<<  >>`,
		Id:         "AddsubdotTerm",
		NTType:     46,
		Index:      134,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm "*" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      135,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm "/" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      136,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm "//" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      137,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm "%!"(MISSING) UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      138,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm ".*" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      139,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm "./" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      140,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : MuldivTerm ".//" UnaryOpTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      141,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `MuldivTerm : UnaryOpTerm	<<  >>`,
		Id:         "MuldivTerm",
		NTType:     47,
		Index:      142,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : "+" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      143,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : "-" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      144,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : ".+" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      145,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : ".-" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      146,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : "!" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      147,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : "~" UnaryOpTerm	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator) >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      148,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `UnaryOpTerm : PowTerm	<<  >>`,
		Id:         "UnaryOpTerm",
		NTType:     48,
		Index:      149,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `PowTerm : PrecedenceChainEnd "**" PowTerm	<< dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator) >>`,
		Id:         "PowTerm",
		NTType:     49,
		Index:      150,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[1], X[0], X[2], dsl.NodeTypeOperator)
		},
	},
	ProdTabEntry{
		String: `PowTerm : PrecedenceChainEnd	<<  >>`,
		Id:         "PowTerm",
		NTType:     49,
		Index:      151,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `PrecedenceChainEnd : "(" Rvalue ")"	<< dsl.Nestable(X[1]) >>`,
		Id:         "PrecedenceChainEnd",
		NTType:     50,
		Index:      152,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.Nestable(X[1])
		},
	},
	ProdTabEntry{
		String: `PrecedenceChainEnd : MlrvalOrFunction	<<  >>`,
		Id:         "PrecedenceChainEnd",
		NTType:     50,
		Index:      153,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : FieldValue	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      154,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : FullSrec	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      155,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : OosvarValue	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      156,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : FullOosvar	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      157,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : LocalVariable	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      158,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : string_literal	<< dsl.NewASTNodeStripDoubleQuotePair(
    X[0],
    dsl.NodeTypeStringLiteral,
  ) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      159,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeStripDoubleQuotePair(
				X[0],
				dsl.NodeTypeStringLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : int_literal	<< dsl.NewASTNode(X[0], dsl.NodeTypeIntLiteral) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      160,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeIntLiteral)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : float_literal	<< dsl.NewASTNode(X[0], dsl.NodeTypeFloatLiteral) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      161,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeFloatLiteral)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : boolean_literal	<< dsl.NewASTNode(X[0], dsl.NodeTypeBoolLiteral) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      162,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeBoolLiteral)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : const_M_PI	<< dsl.NewASTNode(
      X[0],
      dsl.NodeTypeConstant,
    ) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      163,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(
				X[0],
				dsl.NodeTypeConstant,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : const_M_E	<< dsl.NewASTNode(
      X[0],
      dsl.NodeTypeConstant,
    ) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      164,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(
				X[0],
				dsl.NodeTypeConstant,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : panic	<< dsl.NewASTNode(X[0], dsl.NodeTypePanic) >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      165,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypePanic)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ArrayLiteral	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      166,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ArrayLiteral : "[" "]"	<< dsl.NewASTNodeZary(
      dsl.NewASTToken("[]", X[0]),
      dsl.NodeTypeArrayLiteral,
    ) >>`,
		Id:         "ArrayLiteral",
		NTType:     52,
		Index:      167,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(
				dsl.NewASTToken("[]", X[0]),
				dsl.NodeTypeArrayLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `ArrayLiteral : "[" ArrayLiteralElements "]"	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        dsl.NewASTToken("[]", X[0]),
        dsl.NodeTypeArrayLiteral,
      ),
      X[1],
    ) >>`,
		Id:         "ArrayLiteral",
		NTType:     52,
		Index:      168,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					dsl.NewASTToken("[]", X[0]),
					dsl.NodeTypeArrayLiteral,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `ArrayLiteralElements : Rvalue	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeArrayLiteral,
    ) >>`,
		Id:         "ArrayLiteralElements",
		NTType:     53,
		Index:      169,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeArrayLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `ArrayLiteralElements : Rvalue ","	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeArrayLiteral,
    ) >>`,
		Id:         "ArrayLiteralElements",
		NTType:     53,
		Index:      170,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeArrayLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `ArrayLiteralElements : Rvalue "," ArrayLiteralElements	<< dsl.PrependChild(
      X[2],
      X[0],
    ) >>`,
		Id:         "ArrayLiteralElements",
		NTType:     53,
		Index:      171,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(
				X[2],
				X[0],
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : MapLiteral	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      172,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MapLiteral : "{" "}"	<< dsl.NewASTNodeZary(
      dsl.NewASTToken("{}", X[0]),
      dsl.NodeTypeMapLiteral,
    ) >>`,
		Id:         "MapLiteral",
		NTType:     54,
		Index:      173,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(
				dsl.NewASTToken("{}", X[0]),
				dsl.NodeTypeMapLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `MapLiteral : "{" MapLiteralKeyValuePairs "}"	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        dsl.NewASTToken("{}", X[0]),
        dsl.NodeTypeMapLiteral,
      ),
      X[1],
    ) >>`,
		Id:         "MapLiteral",
		NTType:     54,
		Index:      174,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					dsl.NewASTToken("{}", X[0]),
					dsl.NodeTypeMapLiteral,
				),
				X[1],
			)
		},
	},
	ProdTabEntry{
		String: `MapLiteralKeyValuePairs : MapLiteralKeyValuePair	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeMapLiteral,
    ) >>`,
		Id:         "MapLiteralKeyValuePairs",
		NTType:     55,
		Index:      175,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeMapLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `MapLiteralKeyValuePairs : MapLiteralKeyValuePair ","	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeMapLiteral,
    ) >>`,
		Id:         "MapLiteralKeyValuePairs",
		NTType:     55,
		Index:      176,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeMapLiteral,
			)
		},
	},
	ProdTabEntry{
		String: `MapLiteralKeyValuePairs : MapLiteralKeyValuePair "," MapLiteralKeyValuePairs	<< dsl.PrependChild(
      X[2],
      X[0],
    ) >>`,
		Id:         "MapLiteralKeyValuePairs",
		NTType:     55,
		Index:      177,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(
				X[2],
				X[0],
			)
		},
	},
	ProdTabEntry{
		String: `MapLiteralKeyValuePair : Rvalue ":" Rvalue	<< dsl.NewASTNodeBinary(
      X[1],
      X[0],
      X[2],
      dsl.NodeTypeMapLiteralKeyValuePair,
    ) >>`,
		Id:         "MapLiteralKeyValuePair",
		NTType:     56,
		Index:      178,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				X[1],
				X[0],
				X[2],
				dsl.NodeTypeMapLiteralKeyValuePair,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ContextVariable	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      179,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_IPS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      180,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_IFS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      181,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_IRS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      182,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_OPS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      183,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_OFS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      184,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_ORS	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      185,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_NF	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      186,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_NR	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      187,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_FNR	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      188,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_FILENAME	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      189,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `ContextVariable : ctx_FILENUM	<< dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable) >>`,
		Id:         "ContextVariable",
		NTType:     57,
		Index:      190,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeContextVariable)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ENV	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      191,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ENV : env "[" Rvalue "]"	<< dsl.NewASTNodeUnary(
      X[0],
      X[2],
      dsl.NodeTypeEnvironmentVariable,
    ) >>`,
		Id:         "ENV",
		NTType:     58,
		Index:      192,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				X[0],
				X[2],
				dsl.NodeTypeEnvironmentVariable,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ArrayOrMapIndexAccess	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      193,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ArrayOrMapPositionalNameAccess	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      194,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ArrayOrMapPositionalValueAccess	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      195,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : ArraySliceAccess	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      196,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ArrayOrMapIndexAccess : MlrvalOrFunction "[" Rvalue "]"	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      X[2],
      dsl.NodeTypeArrayOrMapIndexAccess,
    ) >>`,
		Id:         "ArrayOrMapIndexAccess",
		NTType:     59,
		Index:      197,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				X[2],
				dsl.NodeTypeArrayOrMapIndexAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArrayOrMapPositionalNameAccess : MlrvalOrFunction "[[" Rvalue "]]"	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      X[2],
      dsl.NodeTypeArrayOrMapPositionalNameAccess,
    ) >>`,
		Id:         "ArrayOrMapPositionalNameAccess",
		NTType:     60,
		Index:      198,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				X[2],
				dsl.NodeTypeArrayOrMapPositionalNameAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArrayOrMapPositionalValueAccess : MlrvalOrFunction "[[[" Rvalue "]]]"	<< dsl.NewASTNodeBinary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      X[2],
      dsl.NodeTypeArrayOrMapPositionalValueAccess,
    ) >>`,
		Id:         "ArrayOrMapPositionalValueAccess",
		NTType:     61,
		Index:      199,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				X[2],
				dsl.NodeTypeArrayOrMapPositionalValueAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArraySliceAccess : MlrvalOrFunction "[" Rvalue ":" Rvalue "]"	<< dsl.NewASTNodeTernary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      X[2],
      X[4],
      dsl.NodeTypeArraySliceAccess,
    ) >>`,
		Id:         "ArraySliceAccess",
		NTType:     62,
		Index:      200,
		NumSymbols: 6,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				X[2],
				X[4],
				dsl.NodeTypeArraySliceAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArraySliceAccess : MlrvalOrFunction "[" ":" Rvalue "]"	<< dsl.NewASTNodeTernary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      dsl.NewASTNodeNestable(
        X[2],
        dsl.NodeTypeArraySliceEmptyLowerIndex,
      ),
      X[3],
      dsl.NodeTypeArraySliceAccess,
    ) >>`,
		Id:         "ArraySliceAccess",
		NTType:     62,
		Index:      201,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				dsl.NewASTNodeNestable(
					X[2],
					dsl.NodeTypeArraySliceEmptyLowerIndex,
				),
				X[3],
				dsl.NodeTypeArraySliceAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArraySliceAccess : MlrvalOrFunction "[" Rvalue ":" "]"	<< dsl.NewASTNodeTernary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      X[2],
      dsl.NewASTNodeNestable(
        X[3],
        dsl.NodeTypeArraySliceEmptyUpperIndex,
      ),
      dsl.NodeTypeArraySliceAccess,
    ) >>`,
		Id:         "ArraySliceAccess",
		NTType:     62,
		Index:      202,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				X[2],
				dsl.NewASTNodeNestable(
					X[3],
					dsl.NodeTypeArraySliceEmptyUpperIndex,
				),
				dsl.NodeTypeArraySliceAccess,
			)
		},
	},
	ProdTabEntry{
		String: `ArraySliceAccess : MlrvalOrFunction "[" ":" "]"	<< dsl.NewASTNodeTernary(
      dsl.NewASTToken("[]", X[1]),
      X[0],
      dsl.NewASTNodeNestable(
        X[2],
        dsl.NodeTypeArraySliceEmptyLowerIndex,
      ),
      dsl.NewASTNodeNestable(
        X[2],
        dsl.NodeTypeArraySliceEmptyUpperIndex,
      ),
      dsl.NodeTypeArraySliceAccess,
    ) >>`,
		Id:         "ArraySliceAccess",
		NTType:     62,
		Index:      203,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				dsl.NewASTToken("[]", X[1]),
				X[0],
				dsl.NewASTNodeNestable(
					X[2],
					dsl.NodeTypeArraySliceEmptyLowerIndex,
				),
				dsl.NewASTNodeNestable(
					X[2],
					dsl.NodeTypeArraySliceEmptyUpperIndex,
				),
				dsl.NodeTypeArraySliceAccess,
			)
		},
	},
	ProdTabEntry{
		String: `MlrvalOrFunction : FunctionCallsite	<<  >>`,
		Id:         "MlrvalOrFunction",
		NTType:     51,
		Index:      204,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FunctionCallsite : FunctionName "(" ")"	<< dsl.NewASTNodeZary(
      X[0],
      dsl.NodeTypeFunctionCallsite,
    ) >>`,
		Id:         "FunctionCallsite",
		NTType:     63,
		Index:      205,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(
				X[0],
				dsl.NodeTypeFunctionCallsite,
			)
		},
	},
	ProdTabEntry{
		String: `FunctionCallsite : FunctionName "(" FcnArgs ")"	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[0],
        dsl.NodeTypeFunctionCallsite,
      ),
      X[2],
    ) >>`,
		Id:         "FunctionCallsite",
		NTType:     63,
		Index:      206,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[0],
					dsl.NodeTypeFunctionCallsite,
				),
				X[2],
			)
		},
	},
	ProdTabEntry{
		String: `FunctionName : non_sigil_name	<<  >>`,
		Id:         "FunctionName",
		NTType:     64,
		Index:      207,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FunctionName : int	<<  >>`,
		Id:         "FunctionName",
		NTType:     64,
		Index:      208,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FunctionName : float	<<  >>`,
		Id:         "FunctionName",
		NTType:     64,
		Index:      209,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `FcnArgs : Rvalue	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeFunctionCallsite,
    ) >>`,
		Id:         "FcnArgs",
		NTType:     65,
		Index:      210,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeFunctionCallsite,
			)
		},
	},
	ProdTabEntry{
		String: `FcnArgs : Rvalue ","	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeFunctionCallsite,
    ) >>`,
		Id:         "FcnArgs",
		NTType:     65,
		Index:      211,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeFunctionCallsite,
			)
		},
	},
	ProdTabEntry{
		String: `FcnArgs : Rvalue "," FcnArgs	<< dsl.PrependChild(
      X[2],
      X[0],
    ) >>`,
		Id:         "FcnArgs",
		NTType:     65,
		Index:      212,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(
				X[2],
				X[0],
			)
		},
	},
	ProdTabEntry{
		String: `SubroutineCallsite : call SubroutineName "(" ")"	<< dsl.NewASTNodeZary(
      X[1],
      dsl.NodeTypeSubroutineCallsite,
    ) >>`,
		Id:         "SubroutineCallsite",
		NTType:     66,
		Index:      213,
		NumSymbols: 4,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(
				X[1],
				dsl.NodeTypeSubroutineCallsite,
			)
		},
	},
	ProdTabEntry{
		String: `SubroutineCallsite : call SubroutineName "(" FcnArgs ")"	<< dsl.AdoptChildren(
      dsl.NewASTNodeNestable(
        X[1],
        dsl.NodeTypeSubroutineCallsite,
      ),
      X[3],
    ) >>`,
		Id:         "SubroutineCallsite",
		NTType:     66,
		Index:      214,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AdoptChildren(
				dsl.NewASTNodeNestable(
					X[1],
					dsl.NodeTypeSubroutineCallsite,
				),
				X[3],
			)
		},
	},
	ProdTabEntry{
		String: `SubroutineName : non_sigil_name	<<  >>`,
		Id:         "SubroutineName",
		NTType:     67,
		Index:      215,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : BeginBlock	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      216,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : EndBlock	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      217,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : CondBlock	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      218,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : IfChain	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      219,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : WhileLoop	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      220,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : ForLoop	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      221,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : FunctionDefinition	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      222,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BracefulStatement : SubroutineDefinition	<<  >>`,
		Id:         "BracefulStatement",
		NTType:     68,
		Index:      223,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `BeginBlock : begin StatementBlockInBraces	<< dsl.NewASTNodeUnary(nil, X[1], dsl.NodeTypeBeginBlock) >>`,
		Id:         "BeginBlock",
		NTType:     69,
		Index:      224,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[1], dsl.NodeTypeBeginBlock)
		},
	},
	ProdTabEntry{
		String: `EndBlock : end StatementBlockInBraces	<< dsl.NewASTNodeUnary(nil, X[1], dsl.NodeTypeEndBlock) >>`,
		Id:         "EndBlock",
		NTType:     70,
		Index:      225,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[1], dsl.NodeTypeEndBlock)
		},
	},
	ProdTabEntry{
		String: `CondBlock : Rvalue StatementBlockInBraces	<< dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeCondBlock) >>`,
		Id:         "CondBlock",
		NTType:     71,
		Index:      226,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(nil, X[0], X[1], dsl.NodeTypeCondBlock)
		},
	},
	ProdTabEntry{
		String: `IfChain : IfElifStar	<<  >>`,
		Id:         "IfChain",
		NTType:     72,
		Index:      227,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `IfChain : IfElifStar ElseBlock	<< dsl.AppendChild(X[0], X[1]) >>`,
		Id:         "IfChain",
		NTType:     72,
		Index:      228,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[0], X[1])
		},
	},
	ProdTabEntry{
		String: `IfElifStar : IfBlock	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeIfChain) >>`,
		Id:         "IfElifStar",
		NTType:     73,
		Index:      229,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeIfChain)
		},
	},
	ProdTabEntry{
		String: `IfElifStar : IfElifStar ElifBlock	<< dsl.AppendChild(X[0], X[1]) >>`,
		Id:         "IfElifStar",
		NTType:     73,
		Index:      230,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[0], X[1])
		},
	},
	ProdTabEntry{
		String: `IfBlock : if "(" Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeIfItem) >>`,
		Id:         "IfBlock",
		NTType:     74,
		Index:      231,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeIfItem)
		},
	},
	ProdTabEntry{
		String: `ElifBlock : elif "(" Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeIfItem) >>`,
		Id:         "ElifBlock",
		NTType:     75,
		Index:      232,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeIfItem)
		},
	},
	ProdTabEntry{
		String: `ElseBlock : else StatementBlockInBraces	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeIfItem) >>`,
		Id:         "ElseBlock",
		NTType:     76,
		Index:      233,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeIfItem)
		},
	},
	ProdTabEntry{
		String: `WhileLoop : while "(" Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeWhileLoop) >>`,
		Id:         "WhileLoop",
		NTType:     77,
		Index:      234,
		NumSymbols: 5,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[0], X[2], X[4], dsl.NodeTypeWhileLoop)
		},
	},
	ProdTabEntry{
		String: `DoWhileLoop : do StatementBlockInBraces while "(" Rvalue ")"	<< dsl.NewASTNodeBinary(X[0], X[1], X[4], dsl.NodeTypeDoWhileLoop) >>`,
		Id:         "DoWhileLoop",
		NTType:     78,
		Index:      235,
		NumSymbols: 6,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(X[0], X[1], X[4], dsl.NodeTypeDoWhileLoop)
		},
	},
	ProdTabEntry{
		String: `ForLoop : ForLoopOneVariable	<<  >>`,
		Id:         "ForLoop",
		NTType:     79,
		Index:      236,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ForLoop : ForLoopTwoVariable	<<  >>`,
		Id:         "ForLoop",
		NTType:     79,
		Index:      237,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ForLoop : ForLoopMultivariable	<<  >>`,
		Id:         "ForLoop",
		NTType:     79,
		Index:      238,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ForLoop : TripleForLoop	<<  >>`,
		Id:         "ForLoop",
		NTType:     79,
		Index:      239,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return X[0], nil
		},
	},
	ProdTabEntry{
		String: `ForLoopOneVariable : for "(" LocalVariable in Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeTernary(
     X[0], // "for"
     X[2], // k, etc.
     X[4], // $*, etc.
     X[6], // { ... }
     dsl.NodeTypeForLoopOneVariable,
   ); >>`,
		Id:         "ForLoopOneVariable",
		NTType:     80,
		Index:      240,
		NumSymbols: 7,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				X[0], // "for"
				X[2], // k, etc.
				X[4], // $*, etc.
				X[6], // { ... }
				dsl.NodeTypeForLoopOneVariable,
			)
		},
	},
	ProdTabEntry{
		String: `ForLoopTwoVariable : for "(" LocalVariable "," LocalVariable in Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeQuaternary(
     X[0], // "for"
     X[2], // k, etc.
     X[4], // v, etc.
     X[6], // $*, etc.
     X[8], // { ... }
     dsl.NodeTypeForLoopTwoVariable,
   ); >>`,
		Id:         "ForLoopTwoVariable",
		NTType:     81,
		Index:      241,
		NumSymbols: 9,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeQuaternary(
				X[0], // "for"
				X[2], // k, etc.
				X[4], // v, etc.
				X[6], // $*, etc.
				X[8], // { ... }
				dsl.NodeTypeForLoopTwoVariable,
			)
		},
	},
	ProdTabEntry{
		String: `ForLoopMultivariable : for "(" "(" MultiIndex ")" "," LocalVariable in Rvalue ")" StatementBlockInBraces	<< dsl.NewASTNodeQuaternary(
     X[0], // "for"
     X[3], // (k1, k2), etc.
     X[6], // v, etc.
     X[8], // $*, etc.
     X[10], // { ... }
     dsl.NodeTypeForLoopMultivariable,
   ); >>`,
		Id:         "ForLoopMultivariable",
		NTType:     82,
		Index:      242,
		NumSymbols: 11,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeQuaternary(
				X[0],  // "for"
				X[3],  // (k1, k2), etc.
				X[6],  // v, etc.
				X[8],  // $*, etc.
				X[10], // { ... }
				dsl.NodeTypeForLoopMultivariable,
			)
		},
	},
	ProdTabEntry{
		String: `MultiIndex : LocalVariable "," LocalVariable	<< dsl.NewASTNodeBinary(
      nil,
      X[0],
      X[2],
      dsl.NodeTypeParameterList,
    ) >>`,
		Id:         "MultiIndex",
		NTType:     83,
		Index:      243,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				nil,
				X[0],
				X[2],
				dsl.NodeTypeParameterList,
			)
		},
	},
	ProdTabEntry{
		String: `MultiIndex : MultiIndex "," LocalVariable	<< dsl.AppendChild(
      X[0],
      X[2],
    ) >>`,
		Id:         "MultiIndex",
		NTType:     83,
		Index:      244,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(
				X[0],
				X[2],
			)
		},
	},
	ProdTabEntry{
		String: `TripleForLoop : for "(" TripleForStart ";" TripleForContinuation ";" TripleForUpdate ")" StatementBlockInBraces	<< dsl.NewASTNodeQuaternary(
     X[0], // for
     X[2], // start
     X[4], // continuation
     X[6], // update
     X[8], // body
     dsl.NodeTypeTripleForLoop,
   ); >>`,
		Id:         "TripleForLoop",
		NTType:     84,
		Index:      245,
		NumSymbols: 9,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeQuaternary(
				X[0], // for
				X[2], // start
				X[4], // continuation
				X[6], // update
				X[8], // body
				dsl.NodeTypeTripleForLoop,
			)
		},
	},
	ProdTabEntry{
		String: `TripleForStart : empty	<< dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForStart",
		NTType:     85,
		Index:      246,
		NumSymbols: 0,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForStart : Assignment	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForStart",
		NTType:     85,
		Index:      247,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForStart : TripleForStart "," Assignment	<< dsl.AppendChild(X[0], X[2]) >>`,
		Id:         "TripleForStart",
		NTType:     85,
		Index:      248,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[0], X[2])
		},
	},
	ProdTabEntry{
		String: `TripleForContinuation : empty	<< dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForContinuation",
		NTType:     86,
		Index:      249,
		NumSymbols: 0,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForContinuation : BracelessStatement	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForContinuation",
		NTType:     86,
		Index:      250,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForUpdate : empty	<< dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForUpdate",
		NTType:     87,
		Index:      251,
		NumSymbols: 0,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(nil, dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForUpdate : Assignment	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock) >>`,
		Id:         "TripleForUpdate",
		NTType:     87,
		Index:      252,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeStatementBlock)
		},
	},
	ProdTabEntry{
		String: `TripleForUpdate : TripleForUpdate "," Assignment	<< dsl.AppendChild(X[0], X[2]) >>`,
		Id:         "TripleForUpdate",
		NTType:     87,
		Index:      253,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[0], X[2])
		},
	},
	ProdTabEntry{
		String: `BreakStatement : break	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeBreak) >>`,
		Id:         "BreakStatement",
		NTType:     88,
		Index:      254,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeBreak)
		},
	},
	ProdTabEntry{
		String: `ContinueStatement : continue	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeContinue) >>`,
		Id:         "ContinueStatement",
		NTType:     89,
		Index:      255,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeContinue)
		},
	},
	ProdTabEntry{
		String: `FunctionDefinition : func non_sigil_name "(" FuncOrSubrParameterList ")" StatementBlockInBraces	<< dsl.NewASTNodeBinary(
      X[1],
      X[3], // parameter list
      X[5], // { ... }
      dsl.NodeTypeFunctionDefinition,
    ); >>`,
		Id:         "FunctionDefinition",
		NTType:     90,
		Index:      256,
		NumSymbols: 6,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				X[1],
				X[3], // parameter list
				X[5], // { ... }
				dsl.NodeTypeFunctionDefinition,
			)
		},
	},
	ProdTabEntry{
		String: `FunctionDefinition : func non_sigil_name "(" FuncOrSubrParameterList ")" ":" Typedecl StatementBlockInBraces	<< dsl.NewASTNodeTernary(
      X[1],
      X[3], // parameter list
      X[7], // {...}
      X[6], // return type
      dsl.NodeTypeFunctionDefinition,
    ); >>`,
		Id:         "FunctionDefinition",
		NTType:     90,
		Index:      257,
		NumSymbols: 8,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeTernary(
				X[1],
				X[3], // parameter list
				X[7], // {...}
				X[6], // return type
				dsl.NodeTypeFunctionDefinition,
			)
		},
	},
	ProdTabEntry{
		String: `SubroutineDefinition : subr non_sigil_name "(" FuncOrSubrParameterList ")" StatementBlockInBraces	<< dsl.NewASTNodeBinary(
      X[1],
      X[3], // parameter list
      X[5], // { ... }
      dsl.NodeTypeSubroutineDefinition,
    ); >>`,
		Id:         "SubroutineDefinition",
		NTType:     91,
		Index:      258,
		NumSymbols: 6,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeBinary(
				X[1],
				X[3], // parameter list
				X[5], // { ... }
				dsl.NodeTypeSubroutineDefinition,
			)
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrParameterList : empty	<< dsl.NewASTNodeZary(nil, dsl.NodeTypeParameterList) >>`,
		Id:         "FuncOrSubrParameterList",
		NTType:     92,
		Index:      259,
		NumSymbols: 0,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(nil, dsl.NodeTypeParameterList)
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrParameterList : FuncOrSubrNonEmptyParameterList	<< dsl.Wrap(X[0]) >>`,
		Id:         "FuncOrSubrParameterList",
		NTType:     92,
		Index:      260,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.Wrap(X[0])
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrNonEmptyParameterList : FuncOrSubrParameter	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeParameterList) >>`,
		Id:         "FuncOrSubrNonEmptyParameterList",
		NTType:     93,
		Index:      261,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeParameterList)
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrNonEmptyParameterList : FuncOrSubrParameter ","	<< dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeParameterList) >>`,
		Id:         "FuncOrSubrNonEmptyParameterList",
		NTType:     93,
		Index:      262,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(nil, X[0], dsl.NodeTypeParameterList)
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrNonEmptyParameterList : FuncOrSubrParameter "," FuncOrSubrNonEmptyParameterList	<< dsl.PrependChild(X[2], X[0]) >>`,
		Id:         "FuncOrSubrNonEmptyParameterList",
		NTType:     93,
		Index:      263,
		NumSymbols: 3,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.PrependChild(X[2], X[0])
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrParameter : UntypedFuncOrSubrParameterName	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeParameter,
    ) >>`,
		Id:         "FuncOrSubrParameter",
		NTType:     94,
		Index:      264,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeParameter,
			)
		},
	},
	ProdTabEntry{
		String: `FuncOrSubrParameter : TypedFuncOrSubrParameterName	<< dsl.NewASTNodeUnary(
      nil,
      X[0],
      dsl.NodeTypeParameter,
    ) >>`,
		Id:         "FuncOrSubrParameter",
		NTType:     94,
		Index:      265,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(
				nil,
				X[0],
				dsl.NodeTypeParameter,
			)
		},
	},
	ProdTabEntry{
		String: `UntypedFuncOrSubrParameterName : non_sigil_name	<< dsl.NewASTNode(X[0], dsl.NodeTypeParameterName) >>`,
		Id:         "UntypedFuncOrSubrParameterName",
		NTType:     95,
		Index:      266,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNode(X[0], dsl.NodeTypeParameterName)
		},
	},
	ProdTabEntry{
		String: `TypedFuncOrSubrParameterName : Typedecl UntypedFuncOrSubrParameterName	<< dsl.AppendChild(X[1], X[0]) >>`,
		Id:         "TypedFuncOrSubrParameterName",
		NTType:     96,
		Index:      267,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.AppendChild(X[1], X[0])
		},
	},
	ProdTabEntry{
		String: `ReturnStatement : return Rvalue	<< dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeReturn) >>`,
		Id:         "ReturnStatement",
		NTType:     97,
		Index:      268,
		NumSymbols: 2,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeUnary(X[0], X[1], dsl.NodeTypeReturn)
		},
	},
	ProdTabEntry{
		String: `ReturnStatement : return	<< dsl.NewASTNodeZary(X[0], dsl.NodeTypeReturn) >>`,
		Id:         "ReturnStatement",
		NTType:     97,
		Index:      269,
		NumSymbols: 1,
		ReduceFunc: func(X []Attrib) (Attrib, error) {
			return dsl.NewASTNodeZary(X[0], dsl.NodeTypeReturn)
		},
	},
}
